$regfile = "m8535.dat"

$hwstack = 40
$swstack = 32
$framesize = 40

$crystal = 14318180
'$baud = 9600


Config Porta = Output                                       'Adresse
Config Portc = Output
Config Pinc.4 = Input

Adresse Alias Porta

Ras Alias Portc.0
Cas Alias Portc.1
Wr Alias Portc.2
Din Alias Portc.3
Dout Alias Pinc.4

Ledgruen Alias Portc.5
Ledrot Alias Portc.6


Dim Zeile As Byte , Spalte As Byte , Maxwert As Byte , Versuch As Byte
Dim Bitzaehler0 As Long , Bitzaehler1 As Long , Fehler As Byte


Start:
'   Print Chr(12) ;
   Versuch = 0
   Fehler = 0
   Reset Ledrot
   Reset Ledgruen

Start2:
   Bitzaehler0 = 0
   Bitzaehler1 = 0
   Set Wr
   Set Ras
   Set Cas

   Select Case Versuch
     Case 0
       Set Din
     Case 1
       Reset Din
     Case 2                                                 'toggle
       Set Din
     Case 3                                                 'toggle
       Reset Din
   End Select

   Zeile = 0
   Spalte = 0
   Maxwert = 255                                            '127

   'Print "Schreibe"

Haupt:
   Adresse = Zeile
   Reset Ras
   'Warte 45(30)ns
   'Waitus 1
   Reset Wr
   Adresse = Spalte
   Reset Cas
   'Warte 60(45)ns
   'Waitus 1
   Set Wr
   Set Ras
   Set Cas
   If Versuch > 1 Then Toggle Din
   Incr Spalte
   If Spalte = 0 Then Goto Zeileneu
   If Spalte > Maxwert Then Goto Zeileneu
   Goto Haupt
Zeileneu:
   Spalte = 0
   Incr Zeile
   If Zeile = 0 Then Goto Auslesen
   If Zeile > Maxwert Then Goto Auslesen
   'Print Zeile
   Goto Haupt


Auslesen:


   Reset Din
   Set Wr
   Set Ras
   Set Cas
   Zeile = 0
   Spalte = 0

   'Print "Lese"


Haupt2:
   Adresse = Zeile
   Reset Ras
   'Warte 45(30)ns
   'Waitus 1
   Adresse = Spalte
   Reset Cas
   'Warte 60(45)ns
   'Waitus 1
   Set Ras
   Set Cas
   If Dout = 0 Then Incr Bitzaehler0 Else Incr Bitzaehler1
Weiter:
   Incr Spalte
   If Spalte = 0 Then Goto Zeileneu2
   If Spalte > Maxwert Then Goto Zeileneu2
   Goto Haupt2
Zeileneu2:
   Spalte = 0
   Incr Zeile
   If Zeile = 0 Then Goto Fertig
   If Zeile > Maxwert Then Goto Fertig
   'Print Zeile
   Goto Haupt2


Fertig:

'   Print "Versuch:" ; Str(versuch)
'   Print "0:" ; Str(bitzaehler0)
'   Print "1:" ; Str(bitzaehler1)
'   Print "------------"

   Select Case Versuch
      Case 0
         If Bitzaehler0 <> 0 Then Fehler = 1
         If Bitzaehler1 <> 65536 Then Fehler = 1
      Case 1
         If Bitzaehler1 <> 0 Then Fehler = 1
         If Bitzaehler0 <> 65536 Then Fehler = 1
      Case 2 To 3
         If Bitzaehler0 <> 32768 Then Fehler = 1
         If Bitzaehler1 <> 32768 Then Fehler = 1
   End Select

   Incr Versuch
   If Versuch > 3 Then
      If Fehler = 0 Then
         Set Ledgruen
      Else
         Set Ledrot
      End If
      Waitms 250
      Goto Start
   Else
      Goto Start2
   End If


   End